<template>
  <form @submit.prevent="submitForm">
    <div class="form-group" :class="{invalid: !firstname.isValid}">
      <label for="firstname">Prénom</label>
      <input class="form-control" type="text" id="firstname" v-model.trim="firstname.val" @blur="clearValidity('firstname')"/>
      <p v-if="!firstname.isValid">Le prénom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !lastname.isValid}">
      <label for="lastname">Nom</label>
      <input class="form-control" type="text" id="lastname" v-model.trim="lastname.val" @blur="clearValidity('lastname')"/>
      <p v-if="!lastname.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !username.isValid}">
      <label for="username">Pseudo</label>
      <input class="form-control" type="text" id="username" v-model.trim="username.val" @blur="clearValidity('username')"/>
      <p v-if="!username.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !email.isValid}">
      <label for="email">Email</label>
      <input class="form-control" type="email" id="email" v-model.trim="email.val" @blur="clearValidity('email')"/>
      <p v-if="!email.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <div class="form-group" :class="{invalid: !roles.isValid}">
      <label for="roles">roles</label>
      <input class="form-control" type="text" id="roles" v-model.trim="roles.val" @blur="clearValidity('roles')"/>
      <p v-if="!roles.isValid">Le nom ne doit pas etre vide.</p>
    </div>
    <base-button>Modifier</base-button>

  </form>
</template>

<script>

export default {
  emits: ['edit-data'],
  props:{
    user : Object
  },
  data() {
    return {
      firstname: {
        val: this.user.firstname,
        isValid: true,
      },
      lastname: {
        val: this.user.lastname,
        isValid: true,
      },
      username: {
        val: this.user.username,
        isValid: true,
      },
      email: {
        val: this.user.email,
        isValid: true,
      },
      roles: {
        val: this.user.roles,
        isValid: true,
      },
      formIsValid: true,
    };
  },
  methods: {
    clearValidity(input) {
      this[input].isValid = true;
    },
    validateForm() {
      this.formIsValid = true;
      if (this.firstname.val === '') {
        this.firstname.isValid = false;
        this.formIsValid = false;
      }
      if (this.lastname.val === '') {
        this.lastname.isValid = false;
        this.formIsValid = false;
      }
      if (this.username.val === '') {
        this.username.isValid = false;
        this.formIsValid = false;
      }
      if (this.email.val === '') {
        this.email.isValid = false;
        this.formIsValid = false;
      }
    },
    submitForm() {
      this.validateForm();

      if (!this.formIsValid) {
        return;
      }

      const formData = this.user
      formData.firstname = this.firstname.val
      formData.lastname = this.lastname.val
      formData.username = this.username.val
      formData.email = this.email.val

      try{
        this.$emit('edit-data', formData);
      }catch (e) {
        console.log(e)
      }
    },
  },
};
</script>

<style scoped>
</style>